


/////////////////////////////////////
//  Generated Initialization File  //
/////////////////////////////////////

#include "C8051F340.h"


// Peripheral specific initialization functions,
// Called from the Init_Device() function
void Timer_Init()
{
	TMR2CN    = 0x00;

    TMR2RL   = 0x00;

	ET2		= 1;
	TR2		= 1;
}


//new
void PCA_Init()
{
    PCA0CN    = 0x40;
    PCA0MD    &= ~0x40;
    PCA0MD    = 0x03;
    PCA0CPM0  = 0xC2;
    PCA0CPM1  = 0xC2;
    PCA0CPM2  = 0x31;

    PCA0CPM3  = 0x10;
}

void SPI_Init()
{
    SPI0CFG   = 0x30;
    SPI0CN    = 0x01;
}


void Port_IO_Init()
{
    P0MDOUT   = 0x3F;
    P1MDOUT   = 0xFF;
    P2MDOUT   = 0xDE;
    P3MDOUT   = 0xFF;
    P4MDOUT   = 0xFF;
    P0SKIP    = 0xE3;
    P1SKIP    = 0xFF;
    P2SKIP    = 0x21;
    P3SKIP    = 0xFF;
    XBR0      = 0x0A;
    XBR1      = 0x45;
    XBR0      = 0x0A;
    XBR1      = 0x45;
}





void ADC_Init()
{
    AMX0P     = 0x04;
    AMX0N     = 0x1F;
    ADC0CN    = 0x82;
}



void Oscillator_Init()
{
    int i = 0;
    OSCICN    = 0x83;
    CLKMUL    = 0x80;
    for (i = 0; i < 20; i++);    // Wait 5us for initialization
    CLKMUL    |= 0xC0;
    while ((CLKMUL & 0x20) == 0);
    CLKSEL    = 0x03;
}

void Interrupts_Init()
{
    IP        = 0x05;
    EIE1      = 0x10;
    EIP1      = 0x10;
    IT01CF    = 0x76;
    IE        = 0xED;
}

// Initialization function for device,
// Call Init_Device() from your main program
void Init_Device(void)
{
    PCA_Init();
    Timer_Init();
    SPI_Init();
    Port_IO_Init();
    Oscillator_Init();
    Interrupts_Init();
}

